// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from tuw_nav_msgs:msg/ControllerState.idl
// generated code does not contain a copyright notice

#ifndef TUW_NAV_MSGS__MSG__DETAIL__CONTROLLER_STATE__STRUCT_H_
#define TUW_NAV_MSGS__MSG__DETAIL__CONTROLLER_STATE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'STATE_IDLE'.
/**
  * controller is inactive
 */
enum
{
  tuw_nav_msgs__msg__ControllerState__STATE_IDLE = 0l
};

/// Constant 'STATE_DRIVING'.
/**
  * controller is driving and following a path
 */
enum
{
  tuw_nav_msgs__msg__ControllerState__STATE_DRIVING = 1l
};

/// Constant 'STATE_FINISHED'.
/**
  * controller finished a path
 */
enum
{
  tuw_nav_msgs__msg__ControllerState__STATE_FINISHED = 2l
};

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'info'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/ControllerState in the package tuw_nav_msgs.
/**
  * Progress/State of a trajectory controller
 */
typedef struct tuw_nav_msgs__msg__ControllerState
{
  /// header, ...
  std_msgs__msg__Header header;
  /// controller state
  int32_t state;
  /// passed waypoints
  uint32_t progress;
  /// id / seq nummer in oder to put the progess in realtion to a waypoint msg or spline msg
  uint32_t progress_in_relation_to;
  /// details on the controller state in human form for debugging only
  rosidl_runtime_c__String info;
} tuw_nav_msgs__msg__ControllerState;

// Struct for a sequence of tuw_nav_msgs__msg__ControllerState.
typedef struct tuw_nav_msgs__msg__ControllerState__Sequence
{
  tuw_nav_msgs__msg__ControllerState * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} tuw_nav_msgs__msg__ControllerState__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // TUW_NAV_MSGS__MSG__DETAIL__CONTROLLER_STATE__STRUCT_H_
