// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from tuw_nav_msgs:msg/PathVec.idl
// generated code does not contain a copyright notice

#ifndef TUW_NAV_MSGS__MSG__DETAIL__PATH_VEC__TRAITS_HPP_
#define TUW_NAV_MSGS__MSG__DETAIL__PATH_VEC__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "tuw_nav_msgs/msg/detail/path_vec__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'paths'
#include "nav_msgs/msg/detail/path__traits.hpp"

namespace tuw_nav_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const PathVec & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: paths
  {
    if (msg.paths.size() == 0) {
      out << "paths: []";
    } else {
      out << "paths: [";
      size_t pending_items = msg.paths.size();
      for (auto item : msg.paths) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PathVec & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: paths
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.paths.size() == 0) {
      out << "paths: []\n";
    } else {
      out << "paths:\n";
      for (auto item : msg.paths) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PathVec & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace tuw_nav_msgs

namespace rosidl_generator_traits
{

[[deprecated("use tuw_nav_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const tuw_nav_msgs::msg::PathVec & msg,
  std::ostream & out, size_t indentation = 0)
{
  tuw_nav_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use tuw_nav_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const tuw_nav_msgs::msg::PathVec & msg)
{
  return tuw_nav_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<tuw_nav_msgs::msg::PathVec>()
{
  return "tuw_nav_msgs::msg::PathVec";
}

template<>
inline const char * name<tuw_nav_msgs::msg::PathVec>()
{
  return "tuw_nav_msgs/msg/PathVec";
}

template<>
struct has_fixed_size<tuw_nav_msgs::msg::PathVec>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<tuw_nav_msgs::msg::PathVec>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<tuw_nav_msgs::msg::PathVec>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // TUW_NAV_MSGS__MSG__DETAIL__PATH_VEC__TRAITS_HPP_
