// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tuw_nav_msgs:msg/RouteSegment.idl
// generated code does not contain a copyright notice

#ifndef TUW_NAV_MSGS__MSG__DETAIL__ROUTE_SEGMENT__STRUCT_HPP_
#define TUW_NAV_MSGS__MSG__DETAIL__ROUTE_SEGMENT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'start'
// Member 'end'
// Member 'center'
#include "geometry_msgs/msg/detail/pose__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__tuw_nav_msgs__msg__RouteSegment __attribute__((deprecated))
#else
# define DEPRECATED__tuw_nav_msgs__msg__RouteSegment __declspec(deprecated)
#endif

namespace tuw_nav_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RouteSegment_
{
  using Type = RouteSegment_<ContainerAllocator>;

  explicit RouteSegment_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : start(_init),
    end(_init),
    center(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0ul;
      this->type = 0;
      this->orientation = 0;
      this->motion_type = 0;
      this->level = 0;
    }
  }

  explicit RouteSegment_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : start(_alloc, _init),
    end(_alloc, _init),
    center(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0ul;
      this->type = 0;
      this->orientation = 0;
      this->motion_type = 0;
      this->level = 0;
    }
  }

  // field types and members
  using _id_type =
    uint32_t;
  _id_type id;
  using _type_type =
    uint8_t;
  _type_type type;
  using _orientation_type =
    uint8_t;
  _orientation_type orientation;
  using _motion_type_type =
    uint8_t;
  _motion_type_type motion_type;
  using _start_type =
    geometry_msgs::msg::Pose_<ContainerAllocator>;
  _start_type start;
  using _end_type =
    geometry_msgs::msg::Pose_<ContainerAllocator>;
  _end_type end;
  using _center_type =
    geometry_msgs::msg::Pose_<ContainerAllocator>;
  _center_type center;
  using _level_type =
    int8_t;
  _level_type level;

  // setters for named parameter idiom
  Type & set__id(
    const uint32_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__type(
    const uint8_t & _arg)
  {
    this->type = _arg;
    return *this;
  }
  Type & set__orientation(
    const uint8_t & _arg)
  {
    this->orientation = _arg;
    return *this;
  }
  Type & set__motion_type(
    const uint8_t & _arg)
  {
    this->motion_type = _arg;
    return *this;
  }
  Type & set__start(
    const geometry_msgs::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->start = _arg;
    return *this;
  }
  Type & set__end(
    const geometry_msgs::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->end = _arg;
    return *this;
  }
  Type & set__center(
    const geometry_msgs::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->center = _arg;
    return *this;
  }
  Type & set__level(
    const int8_t & _arg)
  {
    this->level = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    tuw_nav_msgs::msg::RouteSegment_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_nav_msgs::msg::RouteSegment_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_nav_msgs::msg::RouteSegment_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_nav_msgs::msg::RouteSegment_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_nav_msgs::msg::RouteSegment_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_nav_msgs::msg::RouteSegment_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_nav_msgs::msg::RouteSegment_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_nav_msgs::msg::RouteSegment_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_nav_msgs::msg::RouteSegment_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_nav_msgs::msg::RouteSegment_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_nav_msgs__msg__RouteSegment
    std::shared_ptr<tuw_nav_msgs::msg::RouteSegment_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_nav_msgs__msg__RouteSegment
    std::shared_ptr<tuw_nav_msgs::msg::RouteSegment_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RouteSegment_ & other) const
  {
    if (this->id != other.id) {
      return false;
    }
    if (this->type != other.type) {
      return false;
    }
    if (this->orientation != other.orientation) {
      return false;
    }
    if (this->motion_type != other.motion_type) {
      return false;
    }
    if (this->start != other.start) {
      return false;
    }
    if (this->end != other.end) {
      return false;
    }
    if (this->center != other.center) {
      return false;
    }
    if (this->level != other.level) {
      return false;
    }
    return true;
  }
  bool operator!=(const RouteSegment_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RouteSegment_

// alias to use template instance with default allocator
using RouteSegment =
  tuw_nav_msgs::msg::RouteSegment_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace tuw_nav_msgs

#endif  // TUW_NAV_MSGS__MSG__DETAIL__ROUTE_SEGMENT__STRUCT_HPP_
