// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from tuw_nav_msgs:msg/RouteSegment.idl
// generated code does not contain a copyright notice

#ifndef TUW_NAV_MSGS__MSG__DETAIL__ROUTE_SEGMENT__TRAITS_HPP_
#define TUW_NAV_MSGS__MSG__DETAIL__ROUTE_SEGMENT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "tuw_nav_msgs/msg/detail/route_segment__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'start'
// Member 'end'
// Member 'center'
#include "geometry_msgs/msg/detail/pose__traits.hpp"

namespace tuw_nav_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const RouteSegment & msg,
  std::ostream & out)
{
  out << "{";
  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: type
  {
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << ", ";
  }

  // member: orientation
  {
    out << "orientation: ";
    rosidl_generator_traits::value_to_yaml(msg.orientation, out);
    out << ", ";
  }

  // member: motion_type
  {
    out << "motion_type: ";
    rosidl_generator_traits::value_to_yaml(msg.motion_type, out);
    out << ", ";
  }

  // member: start
  {
    out << "start: ";
    to_flow_style_yaml(msg.start, out);
    out << ", ";
  }

  // member: end
  {
    out << "end: ";
    to_flow_style_yaml(msg.end, out);
    out << ", ";
  }

  // member: center
  {
    out << "center: ";
    to_flow_style_yaml(msg.center, out);
    out << ", ";
  }

  // member: level
  {
    out << "level: ";
    rosidl_generator_traits::value_to_yaml(msg.level, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RouteSegment & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << "\n";
  }

  // member: orientation
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "orientation: ";
    rosidl_generator_traits::value_to_yaml(msg.orientation, out);
    out << "\n";
  }

  // member: motion_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "motion_type: ";
    rosidl_generator_traits::value_to_yaml(msg.motion_type, out);
    out << "\n";
  }

  // member: start
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "start:\n";
    to_block_style_yaml(msg.start, out, indentation + 2);
  }

  // member: end
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "end:\n";
    to_block_style_yaml(msg.end, out, indentation + 2);
  }

  // member: center
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "center:\n";
    to_block_style_yaml(msg.center, out, indentation + 2);
  }

  // member: level
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "level: ";
    rosidl_generator_traits::value_to_yaml(msg.level, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RouteSegment & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace tuw_nav_msgs

namespace rosidl_generator_traits
{

[[deprecated("use tuw_nav_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const tuw_nav_msgs::msg::RouteSegment & msg,
  std::ostream & out, size_t indentation = 0)
{
  tuw_nav_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use tuw_nav_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const tuw_nav_msgs::msg::RouteSegment & msg)
{
  return tuw_nav_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<tuw_nav_msgs::msg::RouteSegment>()
{
  return "tuw_nav_msgs::msg::RouteSegment";
}

template<>
inline const char * name<tuw_nav_msgs::msg::RouteSegment>()
{
  return "tuw_nav_msgs/msg/RouteSegment";
}

template<>
struct has_fixed_size<tuw_nav_msgs::msg::RouteSegment>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::Pose>::value> {};

template<>
struct has_bounded_size<tuw_nav_msgs::msg::RouteSegment>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::Pose>::value> {};

template<>
struct is_message<tuw_nav_msgs::msg::RouteSegment>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // TUW_NAV_MSGS__MSG__DETAIL__ROUTE_SEGMENT__TRAITS_HPP_
